using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using Syncfusion.Grouping;
using Syncfusion.Styles;



namespace SampleSorting
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private DataTable dt = new DataTable("LookUpTable");
		private Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl sortGrouping;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			CreateTable();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//

			sortGrouping.DataSource = dt;
			this.sortGrouping.TableDescriptor.SortedColumns.Add("Column0");
			//this.sortGrouping.TableControl.CurrentCellMoved += new GridCurrentCellMovedEventHandler(TableControl_CurrentCellMoved);
			this.sortGrouping.Table.CurrentRecordContextChange += new CurrentRecordContextChangeEventHandler(sortGrouping_CurrentRecordContextChange);
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.sortGrouping = new Syncfusion.Windows.Forms.Grid.Grouping.GridGroupingControl();
			((System.ComponentModel.ISupportInitialize)(this.sortGrouping)).BeginInit();
			this.SuspendLayout();
			// 
			// sortGrouping
			// 
			this.sortGrouping.BackColor = System.Drawing.SystemColors.Window;
			this.sortGrouping.Location = new System.Drawing.Point(16, 0);
			this.sortGrouping.Name = "sortGrouping";
			this.sortGrouping.Size = new System.Drawing.Size(320, 192);
			this.sortGrouping.TabIndex = 0;
			this.sortGrouping.Text = "gridGroupingControl1";
			this.sortGrouping.VersionInfo = "3.301.0.0";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(352, 254);
			this.Controls.Add(this.sortGrouping);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.sortGrouping)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void CreateTable() {
			
			for(int i = 0;i<4; i++)
			{
				DataColumn col = new DataColumn(string.Format("Column{0}",i));
				dt.Columns.Add(col);
			}

			Random r = new Random();
			for(int i = 0;i<20;i++)
			{
				DataRow row = dt.NewRow();
						row[0] = i;
						row[1] = r.Next(10);
						row[2] = r.Next(10);
						row[3] = r.Next(10);
				dt.Rows.Add(row);
			}

		
		}

	
		
//		private void TableControl_CurrentCellMoved(object sender, GridCurrentCellMovedEventArgs e)
//		{
//			int row = this.sortGrouping.Table.DisplayElements.IndexOf(this.sortGrouping.Table.CurrentRecord);
//			if(!this.sortGrouping.TableControl.ViewLayout.IsRowVisible(row))
//			{
//				Console.WriteLine("Current RowIndex: {0}",row);
//				this.sortGrouping.TableControl.CurrentCell.ScrollInView();
//				this.sortGrouping.Table.CurrentRecord.SetSelected(true);
//			}
//
//		}

		bool lastAddNewRow = false;
		private void sortGrouping_CurrentRecordContextChange(object sender, CurrentRecordContextChangeEventArgs e)
		{
			this.sortGrouping.TableControl.Table.SelectedRecords.Clear(); 
			Record _rec = e.Record as Record;
			if((e.Action == CurrentRecordAction.EndEditCalled) && (e.Record.Kind == DisplayElementKind.AddNewRecord))
			{
				_rec.SetCurrent(); 
				lastAddNewRow = true;
				
			}
			else
			if(lastAddNewRow && e.Action == CurrentRecordAction.EndEditComplete)
			{
				int row = this.sortGrouping.Table.DisplayElements.IndexOf(this.sortGrouping.Table.CurrentRecord);
				Console.WriteLine("Current RowIndex: {0}",row);
				_rec.SetSelected(true);
				lastAddNewRow = false;
			}

		}
	}

	
}
